<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML3.2 EN">
<HTML>
<HEAD>
<META NAME="GENERATOR" CONTENT="DOCTEXT">
<TITLE>MatZeroRows</TITLE>
</HEAD>
<BODY BGCOLOR="FFFFFF">
<A NAME="MatZeroRows"><H1>MatZeroRows</H1></A>
Zeros all entries (except possibly the main diagonal) of a set of rows of a matrix. 
<H3><FONT COLOR="#CC3333">Synopsis</FONT></H3>
<PRE>
#include "petscmat.h" 
PetscErrorCode  MatZeroRows(Mat mat,PetscInt numRows,const PetscInt rows[],PetscScalar diag)
</PRE>
Collective on <A HREF="../Mat/Mat.html#Mat">Mat</A>
<P>
<H3><FONT COLOR="#CC3333">Input Parameters</FONT></H3>
<TABLE border="0" cellpadding="0" cellspacing="0">
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>mat </B></TD><TD>- the matrix
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>numRows </B></TD><TD>- the number of rows to remove
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>rows </B></TD><TD>- the global row indices
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>diag </B></TD><TD>- value put in all diagonals of eliminated rows
</TD></TR></TABLE>
<P>
<H3><FONT COLOR="#CC3333">Notes</FONT></H3>
For the AIJ and BAIJ matrix formats this removes the old nonzero structure,
but does not release memory.  For the dense and block diagonal
formats this does not alter the nonzero structure.
<P>
If the option <A HREF="../Mat/MatSetOption.html#MatSetOption">MatSetOption</A>(mat,MAT_KEEP_ZEROED_ROWS) the nonzero structure
of the matrix is not changed (even for AIJ and BAIJ matrices) the values are
merely zeroed.
<P>
The user can set a value in the diagonal entry (or for the AIJ and
row formats can optionally remove the main diagonal entry from the
nonzero structure as well, by passing 0.0 as the final argument).
<P>
For the parallel case, all processes that share the matrix (i.e.,
those in the communicator used for matrix creation) MUST call this
routine, regardless of whether any rows being zeroed are owned by
them.
<P>
Each processor should list the rows that IT wants zeroed
<P>

<P>
<P>
<H3><FONT COLOR="#CC3333">See Also</FONT></H3>
 <A HREF="../Mat/MatZeroRowsIS.html#MatZeroRowsIS">MatZeroRowsIS</A>(), <A HREF="../Mat/MatZeroEntries.html#MatZeroEntries">MatZeroEntries</A>(), <A HREF="../Mat/MatZeroRowsLocal.html#MatZeroRowsLocal">MatZeroRowsLocal</A>(), <A HREF="../Mat/MatSetOption.html#MatSetOption">MatSetOption</A>()
<BR><P><B><P><B><FONT COLOR="#CC3333">Level:</FONT></B>intermediate
<BR><FONT COLOR="#CC3333">Location:</FONT></B><A HREF="../../../src/mat/interface/matrix.c.html#MatZeroRows">src/mat/interface/matrix.c</A>
<BR><A HREF="./index.html">Index of all Mat routines</A>
<BR><A HREF="../../index.html">Table of Contents for all manual pages</A>
<BR><A HREF="../singleindex.html">Index of all manual pages</A>
<P><H3><FONT COLOR="#CC3333">Examples</FONT></H3>
<A HREF="../../../src/ksp/ksp/examples/tutorials/ex3.c.html">src/ksp/ksp/examples/tutorials/ex3.c.html</A><BR>
<A HREF="../../../src/ksp/ksp/examples/tutorials/ex33.c.html">src/ksp/ksp/examples/tutorials/ex33.c.html</A><BR>
</BODY></HTML>
